<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}
require_once plugin_dir_path( __FILE__ ) . 'register-categories.php';

define( 'DEXEN_FILE', __FILE__ );
define( 'DEXEN_PATH', dirname( DEXEN_FILE ) );
define( 'DEXEN_URL', plugins_url( '', DEXEN_FILE ) );

if ( ! function_exists( 'dexen_custom_icon' ) ) {
	function dexen_custom_icon( $array ) {
		$plugin_url = plugins_url();
		return array(
			'custom-icon' => array(
				'name'          => 'custom-icon',
				'label'         => 'Dexen Icon',
				'url'           => '',
				'enqueue'       => array(
					$plugin_url . '/dexen-core/elementor-addons/assets/icon/style.css',
				),
				'prefix'        => '',
				'displayPrefix' => '',
				'labelIcon'     => 'fab fa-font-awesome-alt',
				'ver'           => '5.9.0',
				'fetchJson'     => $plugin_url . '/dexen-core/elementor-addons/assets/js/regular.js',
				'native'        => 1,
			),
		);
	}
}
add_filter( 'elementor/icons_manager/additional_tabs', 'dexen_custom_icon' );

/**
 * Main Dexencore Class
 *
 * The main class that initiates and runs the plugin.
 *
 * @since 1.0.0
 */
final class Dexen_Elementor {

	/**
	 * Plugin Version
	 *
	 * @since 1.0.0
	 *
	 * @var string The plugin version.
	 */
	const VERSION = '1.0.0';

	/**
	 * Minimum Elementor Version
	 *
	 * @since 1.0.0
	 *
	 * @var string Minimum Elementor version required to run the plugin.
	 */
	const MINIMUM_ELEMENTOR_VERSION = '2.0.0';

	/**
	 * Minimum PHP Version
	 *
	 * @since 1.0.0
	 *
	 * @var string Minimum PHP version required to run the plugin.
	 */
	const MINIMUM_PHP_VERSION = '5.6';

	/**
	 * Instance
	 *
	 * @since 1.0.0
	 *
	 * @access private
	 * @static
	 *
	 * @var Dexen_Elementor The single instance of the class.
	 */
	private static $_instance = null;

	/**
	 * Instance
	 *
	 * Ensures only one instance of the class is loaded or can be loaded.
	 *
	 * @since 1.0.0
	 *
	 * @access public
	 * @static
	 *
	 * @return Dexen_Elementor An instance of the class.
	 */
	public static function instance() {

		if ( is_null( self::$_instance ) ) {
			self::$_instance = new self();
		}
		return self::$_instance;

	}

	/**
	 * Constructor
	 *
	 * @since 1.0.0
	 *
	 * @access public
	 */
	public function __construct() {

		add_action( 'init', array( $this, 'i18n' ) );
		add_action( 'plugins_loaded', array( $this, 'init' ) );

	}

	/**
	 * Load Textdomain
	 *
	 * Load plugin localization files.
	 *
	 * Fired by `init` action hook.
	 *
	 * @since 1.0.0
	 *
	 * @access public
	 */
	public function i18n() {

		load_plugin_textdomain( 'dexencore' );

	}

	/**
	 * Initialize the plugin
	 *
	 * Load the plugin only after Elementor (and other plugins) are loaded.
	 * Checks for basic plugin requirements, if one check fail don't continue,
	 * if all check have passed load the files required to run the plugin.
	 *
	 * Fired by `plugins_loaded` action hook.
	 *
	 * @since 1.0.0
	 *
	 * @access public
	 */
	public function init() {

		// Check if Elementor installed and activated
		if ( ! did_action( 'elementor/loaded' ) ) {
			add_action( 'admin_notices', array( $this, 'admin_notice_missing_main_plugin' ) );
			return;
		}

		// Check for required Elementor version
		if ( ! version_compare( ELEMENTOR_VERSION, self::MINIMUM_ELEMENTOR_VERSION, '>=' ) ) {
			add_action( 'admin_notices', array( $this, 'admin_notice_minimum_elementor_version' ) );
			return;
		}

		// Check for required PHP version
		if ( version_compare( PHP_VERSION, self::MINIMUM_PHP_VERSION, '<' ) ) {
			add_action( 'admin_notices', array( $this, 'admin_notice_minimum_php_version' ) );
			return;
		}

		// Add Plugin actions
		add_action( 'elementor/widgets/widgets_registered', array( $this, 'init_widgets' ) );
		add_action( 'elementor/frontend/after_register_scripts', array( $this, 'dexen_register_fronted_scripts' ), 10 );
	}
	// Register frontend script
	public function dexen_register_fronted_scripts() {
		$plugin_url = plugins_url();
		wp_register_script( 'owl-carousel', $plugin_url . '/dexen-core/elementor-addons/assets/js/owl.carousel.min.js', array( 'jquery' ), 1.1, true, true );
		wp_register_script( 'swiper-slide', $plugin_url . '/dexen-core/elementor-addons/assets/js/swiper.min.js', array( 'jquery' ), 1.1, true, true );
		wp_register_script( 'dexen-elementor-script', plugins_url( 'assets/js/addons-script.js', __FILE__ ), array( 'jquery', 'owl-carousel', 'swiper-slide' ), true, true );
	}

	/**
	 * Admin notice
	 *
	 * Warning when the site doesn't have Elementor installed or activated.
	 *
	 * @since 1.0.0
	 *
	 * @access public
	 */
	public function admin_notice_missing_main_plugin() {

		if ( isset( $_GET['activate'] ) ) {
			unset( $_GET['activate'] );
		}

		$message = sprintf(
			/* translators: 1: Plugin name 2: Elementor */
			esc_html__( '"%1$s" requires "%2$s" to be installed and activated.', 'dexencore' ),
			'<strong>' . esc_html__( 'Dexencore', 'dexencore' ) . '</strong>',
			'<strong>' . esc_html__( 'Elementor', 'dexencore' ) . '</strong>'
		);

		printf( '<div class="notice notice-warning is-dismissible"><p>%1$s</p></div>', $message );

	}

	/**
	 * Admin notice
	 *
	 * Warning when the site doesn't have a minimum required Elementor version.
	 *
	 * @since 1.0.0
	 *
	 * @access public
	 */
	public function admin_notice_minimum_elementor_version() {

		if ( isset( $_GET['activate'] ) ) {
			unset( $_GET['activate'] );
		}

		$message = sprintf(
			/* translators: 1: Plugin name 2: Elementor 3: Required Elementor version */
			esc_html__( '"%1$s" requires "%2$s" version %3$s or greater.', 'dexencore' ),
			'<strong>' . esc_html__( 'Dexencore', 'dexencore' ) . '</strong>',
			'<strong>' . esc_html__( 'Elementor', 'dexencore' ) . '</strong>',
			self::MINIMUM_ELEMENTOR_VERSION
		);

		printf( '<div class="notice notice-warning is-dismissible"><p>%1$s</p></div>', $message );

	}

	/**
	 * Admin notice
	 *
	 * Warning when the site doesn't have a minimum required PHP version.
	 *
	 * @since 1.0.0
	 *
	 * @access public
	 */
	public function admin_notice_minimum_php_version() {

		if ( isset( $_GET['activate'] ) ) {
			unset( $_GET['activate'] );
		}

		$message = sprintf(
			/* translators: 1: Plugin name 2: PHP 3: Required PHP version */
			esc_html__( '"%1$s" requires "%2$s" version %3$s or greater.', 'dexencore' ),
			'<strong>' . esc_html__( 'Dexencore', 'dexencore' ) . '</strong>',
			'<strong>' . esc_html__( 'PHP', 'dexencore' ) . '</strong>',
			self::MINIMUM_PHP_VERSION
		);

		printf( '<div class="notice notice-warning is-dismissible"><p>%1$s</p></div>', $message );

	}
	/**
	 * Init Widgets
	 *
	 * Include widgets files and register them
	 *
	 * @since 1.0.0
	 *
	 * @access public
	 */
	public function init_widgets() {
		require_once __DIR__ . '/header-settings.php';
		require_once __DIR__ . '/addons/dexen-banner-slider-one.php';
		require_once __DIR__ . '/addons/dexen-contact-form7.php';
		require_once __DIR__ . '/addons/dexen-counterup.php';
		require_once __DIR__ . '/addons/dexen-testimonial.php';
		require_once __DIR__ . '/addons/dexen-brands.php';
		require_once __DIR__ . '/addons/dexen-call-to-action.php';
		require_once __DIR__ . '/addons/dexen-pricing-table.php';
		require_once __DIR__ . '/addons/dexen-our-team.php';
		require_once __DIR__ . '/addons/dexen-recent-project.php';
		require_once __DIR__ . '/addons/dexen-faq.php';
		require_once __DIR__ . '/addons/dexen-blogs.php';
		require_once __DIR__ . '/addons/dexen-cta-three.php';
		require_once __DIR__ . '/addons/dexen-contact-two.php';
		require_once __DIR__ . '/addons/dexen-services.php';
		require_once __DIR__ . '/addons/dexen-banner-home-2.php';
		require_once __DIR__ . '/addons/dexen-about-two.php';
		require_once __DIR__ . '/addons/dexen-pricing-list.php';
		require_once __DIR__ . '/addons/dexen-download.php';
		require_once __DIR__ . '/addons/dexen-footer-site-info.php';
		require_once __DIR__ . '/addons/dexen-footer-gallery.php';
		require_once __DIR__ . '/addons/dexen-about-us-list.php';
		require_once __DIR__ . '/addons/dexen-single-project-img.php';
		require_once __DIR__ . '/addons/dexen-single-project-info.php';
		require_once __DIR__ . '/addons/dexen-footer-subscribe.php';
	}
}
Dexen_Elementor::instance();
